import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;

public class RemoconIFPanel extends Panel implements 
					TimerListener,
					SoftKeyListener,
					KeyListener 
{
	IApplication parent;
	Label statusLabel;
	Label timeLabel;
	ImageLabel imageLabel1;
	ImageLabel imageLabel2;
	RemoteManager rm = null;
	Timer animationTimer;
	MediaImage[] mi;
	Image[] animationImage1;
	int currentPattern;
	
	boolean lock = false;
	
	/**
	 * RXgN^[
	 * @param p
	 */
	RemoconIFPanel(IApplication p) {
		try {
			parent = p;
			
			// RpǗNXCX^X
			rm = new RemoteManager();
			
			//摜\[X擾
			mi = new MediaImage[] {
					 MediaManager.getImage("resource:///IMAGE001.gif")
					,MediaManager.getImage("resource:///IMAGE002.gif")
					,MediaManager.getImage("resource:///IMAGE003.gif")
					,MediaManager.getImage("resource:///IMAGE004.gif")
			};
			for(int i=0;i<mi.length;i++) {
				mi[i].use();
			}
			
			MediaImage remm = MediaManager.getImage("resource:///REMCNIMG.gif");
			remm.use();
			
			//Aj[VC[W
			animationImage1 = new Image[] { 
			        mi[0].getImage()
					,mi[1].getImage()
					,mi[2].getImage()
				    ,mi[3].getImage()
			};		

			//@ʃR|[lgݒ
			HTMLLayout hl = new HTMLLayout();
			setLayoutManager(hl);
			hl.br();
			hl.begin( HTMLLayout.CENTER) ;

			//Aj[VC[W
			imageLabel1 = new ImageLabel(mi[0].getImage());
			add(imageLabel1);
			hl.br();		
			
			//R{̃C[W
			imageLabel2 = new ImageLabel(remm.getImage());
			add(imageLabel2);
			hl.br();		

			//Xe[^Xx
			statusLabel = new Label("");
			add(statusLabel);
			hl.br();		

			//Iԃx
			timeLabel = new Label("");
			add(timeLabel);
			hl.br();		

			hl.end();
			
			//
			add(new Label("[1]:ouJn"));
			hl.br();		
			add(new Label("[2]:Vb^["));
			hl.br();		
			add(new Label("[3]:ouI"));
			
			//\tgL[ݒ
			setSoftLabel(SOFT_KEY_1,"");
			setSoftLabel(SOFT_KEY_2,"I");

			//Aj[VCxgݒ
			animationTimer = new Timer();
			animationTimer.setTime(250);
			animationTimer.setListener(this);
			animationTimer.setRepeat(true);

			//Cxgݒ
			setSoftKeyListener(this);
			setKeyListener(this);
			
		} catch(Exception e) {
			Dialog dlg = new Dialog( Dialog.BUTTON_OK,"ImageSample"); 
			dlg.setText("vIȃG[H");
			dlg.show();
		}
    }
	
	/**
	 * IJn
	 */
	protected void shutter_down() {
		rm.start();
		currentPattern =3;
		imageLabel1.setImage(mi[currentPattern].getImage());
		statusLabel.setText("I...");
		timeLabel.setText("0b");
		animationTimer.start();
	}

	/**
	 * II
	 */
	protected void shutter_up() {
		rm.stop();
		animationTimer.stop();
		statusLabel.setText("");
		timeLabel.setText("");
		currentPattern =0;
		imageLabel1.setImage(mi[currentPattern].getImage());
	}
	
	/**
	 * \tgL[vXCxg
	 */
	public void softKeyPressed(int key ) {
		if(key == Frame.SOFT_KEY_1 && lock == false) {
			shutter_down();
		}
	}

	/**
	 * \tgL[[XCxg
	 */
	public void softKeyReleased(int key) {
		if(key == Frame.SOFT_KEY_1 && lock == false) {
			shutter_up();
		}
		if(key == Frame.SOFT_KEY_2) {
			parent.terminate();
		}
	}
	
	/**
	 * L[vXCxg
	 */
	public void keyPressed(Panel p, int key ) {
		if(key == Display.KEY_1 && lock == false) {
			shutter_down();
			lock = true;
		}
		if(key == Display.KEY_2 && lock == false) {
			shutter_down();
		}
		if(key == Display.KEY_3 && lock == true) {
			shutter_up();
			lock = false;
		}
	}

	/**
	 * L[[XCxg
	 */
	public void keyReleased(Panel p, int key) {
		if(key == Display.KEY_2 && lock == false) {
			shutter_up();
		}
	}

	/**
	 * Aj[V^C}[
	 */
	public void timerExpired(Timer arg0) {
		int pat = (int)(rm.getReleaseTime() / 500) % animationImage1.length;
		if(currentPattern != pat) {
			imageLabel1.setImage(animationImage1[pat]);
		}
		currentPattern = pat;
		timeLabel.setText(String.valueOf((int)(rm.getReleaseTime() / 1000))+"b");
	}
}
