import com.nttdocomo.device.*;

/**
 * RǗpNX
 *
 *@EԊOo͂̏
 *@EIԂ̊Ǘ
 *@EIrRemoteControl30bȏݒłȂƂ
 */
public class RemoteManager implements Runnable {

	static final int STATUS_RELEASE = 0;
	static final int STATUS_STOP = 1;
	
	static final long RE_RELEASE_TIME = 29000;
	
	int freq = 38; // KHz
	int base = 1000; //usec

	IrRemoteControl irc;
	Thread th;
	protected int status;
	protected long release_time;
	protected long continue_time;
	
	synchronized public void setStatus(int st) {
		this.status = st;
	}
	synchronized public int getStatus() {
		return status;
	}
	
	public long getReleaseTime() {
		return System.currentTimeMillis() - release_time ;
	}
	
	public void run() {
		try {
			while(getStatus() == STATUS_RELEASE) {
				if(release_time == 0) {
					firstRelease();
				} else {
					if((System.currentTimeMillis() - continue_time ) > RE_RELEASE_TIME) {
						if(irc != null ) irc.stop();
						irc = null;
						continueRelease();
					}
				}
				Thread.sleep(20);
			}
		} catch(InterruptedException e) {
		} catch(Exception e) {
		}
		if(irc != null ) irc.stop();
		irc = null;
		return;
	}
	
	protected RemoteManager() {
		reset();
	}
	protected void reset() {
		irc = null;
		release_time = 0;
		continue_time = 0;
		th = null;
	}

	public void start() {
		reset();

		setStatus(STATUS_RELEASE);
		th = new Thread(this);
		th.start();
	}
	
	public void stop() {
		setStatus(STATUS_STOP);
		if(irc != null) {
			irc.stop();
			irc = null;
		}
		reset();
	}
	
	protected void firstRelease() {
		release_time = System.currentTimeMillis();
		continue_time = release_time;
		irc = IrRemoteControl.getIrRemoteControl();

		try {
			irc.setCarrier(5000 / freq, 5000 / freq); // ʓIȃLA
			// 0:High=1ms,Low=1ms
			irc.setCode0(IrRemoteControl.PATTERN_HL, base * 1, base * 1);
			// 1:High=3ms,Low=3ms
			irc.setCode1(IrRemoteControl.PATTERN_HL, base * 3, base * 3);

			// Jnt[
			IrRemoteControlFrame frame1 = new IrRemoteControlFrame();
			frame1.setFrameData(new byte[] { (byte) 0x80 }, 8);
			frame1.setStartHighDuration(base * 10); // X^[g10ms
			frame1.setStartLowDuration(0); // 1Ƃ킹13ms+3ms
			frame1.setStopHighDuration(0); // XgbvpX͎gȂ
			frame1.setFrameDuration(450 * 10); // t[(0.1ms)
			frame1.setRepeatCount(1);

			// [YppXt[
			IrRemoteControlFrame frame2 = new IrRemoteControlFrame();
			frame2.setFrameData(new byte[] { (byte) 0x0 }, 0);
			frame2.setStartHighDuration(base * 4); // 4mspX
			frame2.setStartLowDuration(0);
			frame2.setStopHighDuration(0);
			frame2.setFrameDuration(250 * 10);
			frame2.setRepeatCount(IrRemoteControlFrame.COUNT_INFINITE);

			IrRemoteControlFrame[] ircf = new IrRemoteControlFrame[] { frame1, frame2 };
			irc.send(ircf.length, ircf, 30); // M
		} catch (Exception e) {
		}
		return;
	}
	
	protected void continueRelease() {
		continue_time = System.currentTimeMillis();
		irc = IrRemoteControl.getIrRemoteControl();

		try {
			irc.setCarrier(5000 / freq, 5000 / freq); // ʓIȃLA
			// 0:High=1ms,Low=1ms
			irc.setCode0(IrRemoteControl.PATTERN_HL, base * 1, base * 1);
			// 1:High=3ms,Low=3ms
			irc.setCode1(IrRemoteControl.PATTERN_HL, base * 3, base * 3);

			// [YppXt[
			IrRemoteControlFrame frame = new IrRemoteControlFrame();
			frame.setFrameData(new byte[] { (byte) 0x0 }, 0);
			frame.setStartHighDuration(base * 4); // 4mspX
			frame.setStartLowDuration(0);
			frame.setStopHighDuration(0);
			frame.setFrameDuration(250 * 10);
			frame.setRepeatCount(IrRemoteControlFrame.COUNT_INFINITE);

			IrRemoteControlFrame[] ircf = new IrRemoteControlFrame[] { frame };
			irc.send(ircf.length, ircf, 30); // M
		} catch (Exception e) {
		}
		return;
	}
}